# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes | List of all members
dirac::QualityMonitor Class Reference

Class to monitor the quality of pictures and adjust coding parameters appropriately.

`#include <quality_monitor.h>`

## Public Member Functions
| QualityMonitor (EncoderParams &ep)
| Constructor. Sets up initial Lagrangian values. More...
| ~QualityMonitor ()
| Destructor. More...
void | UpdateModel (const EncPicture &enc_picture)
| Update the mse factors, returning true if we need to recode. More...
void | ResetAll ()
| Reset the quality factors (say if there's been a cut) More...
void | WriteLog ()
| Write a log of the quality to date. More...

## Private Member Functions
double | QualityVal (const PicArray &coded_data, const PicArray &orig_data, const int xlen, const int ylen)
| Calculate the quality of coded wrt original picture. More...

## Private Attributes
EncoderParams & | m_encparams
| A reference to the encoder parameters. More...
long double | m_totalmse_averageY
| The overall average Y mse. More...
long double | m_totalmse_averageU
| The overall average U mse. More...
long double | m_totalmse_averageV
| The overall average V mse. More...
int | m_allpicture_total
| The total number of pictures coded. More...
OneDArray< long double > | m_mse_averageY
| The average Y mse for the picture types. More...
OneDArray< long double > | m_mse_averageU
| The average U mse for the picture types. More...
OneDArray< long double > | m_mse_averageV
| The average V mse for the picture types. More...
OneDArray< int > | m_picture_total
| The number of pictures of each type. More...

## Constructor & Destructor Documentation

dirac::QualityMonitor::QualityMonitor | ( | EncoderParams & | ep | ) |

dirac::QualityMonitor::~QualityMonitor | ( |  | ) |

## Member Function Documentation

double dirac::QualityMonitor::QualityVal | ( | const PicArray & | coded_data,
|  | const PicArray & | orig_data,
|  | const int | xlen,
|  | const int | ylen
| ) |  |
| private

void dirac::QualityMonitor::ResetAll | ( |  | ) |

void dirac::QualityMonitor::UpdateModel | ( | const EncPicture & | enc_picture | ) |

Update the mse factors, returning true if we need to recode

Parameters

  enc_picture | the picture being encoded

void dirac::QualityMonitor::WriteLog | ( |  | ) |

## Member Data Documentation

int dirac::QualityMonitor::m_allpicture_total
| private

EncoderParams& dirac::QualityMonitor::m_encparams
| private

OneDArray<long double> dirac::QualityMonitor::m_mse_averageU
| private

OneDArray<long double> dirac::QualityMonitor::m_mse_averageV
| private

OneDArray<long double> dirac::QualityMonitor::m_mse_averageY
| private

OneDArray<int> dirac::QualityMonitor::m_picture_total
| private

long double dirac::QualityMonitor::m_totalmse_averageU
| private

long double dirac::QualityMonitor::m_totalmse_averageV
| private

long double dirac::QualityMonitor::m_totalmse_averageY
| private

The documentation for this class was generated from the following file:

- quality_monitor.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.